
import java.net.*;
import java.io.*;
import java.nio.*;
import java.util.regex.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.text.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.nio.channels.*;
import java.awt.image.*;
import javax.imageio.*;
import javax.net.*;
import javax.net.ssl.*;
import java.security.*;
import java.util.jar.*;
import java.security.cert.*;
import java.math.*;

public class GameStatePanel extends JPanel {
    Map<String, BufferedImage> images = new HashMap<String, BufferedImage>();
    int tileWidth;
    int tileHeight;
    int boardWidth;
    int boardHeight;
    Set<String> mines = new HashSet<String>();
    Set<String> explored = new HashSet<String>();
    
    public static void main(String[] args) throws Exception {
        JFrame f = new JFrame("hello");
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        f.getContentPane().setLayout(new BorderLayout());
        f.getContentPane().add(new GameStatePanel());
        
        f.pack();
        f.show();
    }
    
    public GameStatePanel() throws Exception {
        for (File f : new File("images").listFiles()) {
            images.put(u.trimExtension(f.getName()), ImageIO.read(f));
        }
        BufferedImage genericTile = images.get("1");
        tileWidth = genericTile.getWidth();
        tileHeight = genericTile.getHeight();
        
        boardWidth = 10;
        boardHeight = 10;
        
        for (int i = 0; i < 40; i++) {
            layMine(u.r.nextInt(boardWidth), u.r.nextInt(boardHeight));
        }
        for (int i = 0; i < 100; i++) {
            explore(u.r.nextInt(boardWidth), u.r.nextInt(boardHeight));
        }
    }
    
    public Dimension getPreferredSize() {
        return new Dimension(boardWidth * tileWidth, boardHeight * tileHeight);
    }
    
    public void layMine(int x, int y) {
        mines.add("" + x + "," + y);
    }
    
    public void explore(int x, int y) {
        explored.add("" + x + "," + y);
    }
    
    public int countMinesAround(int x, int y) {
        int mineCount = 0;
        for (int offsetX = -1; offsetX <= 1; offsetX++) {
            for (int offsetY = -1; offsetY <= 1; offsetY++) {
                if (offsetX == 0 && offsetY == 0) continue;
                    
                String spot = "" + (x + offsetX) + "," + (y + offsetY);
                if (mines.contains(spot)) {
                    mineCount++;
                }
            }
        }
        return mineCount;
    }
    
    public String getSpotType(int x, int y) {
        String spot = "" + x + "," + y;
        if (explored.contains(spot)) {
            if (mines.contains(spot)) {
                return "mine";
            } else {
                return "" + countMinesAround(x, y);
            }
        } else {
            return "unexplored";
        }
    }
    
    public void paint(Graphics g1) {
        Graphics2D g = (Graphics2D)g1;
        
        for (int x = 0; x < boardWidth; x++) {
            for (int y = 0; y < boardHeight; y++) {
                g.drawImage(images.get(getSpotType(x, y)), x * tileWidth, y * tileHeight, this);
            }
        }
    }
}
